@echo off

@echo *************************
@echo FeedDemon Database Repair
@echo *************************

@echo.
@echo Please make sure that FeedDemon isn't running before continuing!
PAUSE

@echo.
@echo Repairing database...

:: Delete copies left behind from previous repair
IF EXIST feeds.fdb.new DEL feeds.fdb.new /Q
IF EXIST feeds.fdb.old DEL feeds.fdb.old /Q

:: Dump the corrupt database to a new database
sqlite3.exe feeds.fdb .dump | sqlite3.exe feeds.fdb.new

:: Go no further if dump failed
IF ERRORLEVEL 1 GOTO Failed
IF NOT EXIST feeds.fdb.new GOTO Failed

:: Rename the corrupted database
RENAME feeds.fdb feeds.fdb.old
IF ERRORLEVEL 1 GOTO Failed

:: Rename the repaired database
RENAME feeds.fdb.new feeds.fdb
IF ERRORLEVEL 1 GOTO Failed

:: FeedDemon detects 9999 and knows that it means DB was repaired
sqlite3.exe feeds.fdb "PRAGMA user_version=9999;"

@echo.
@echo Repair completed
PAUSE
EXIT

:Failed
@echo.
@echo REPAIR FAILED
PAUSE
EXIT